#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire400six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six4004xi




# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six4004xi = {
                1:'-100x368y-119z',
                2:'-102x252y-293z',
                3:'-105x368y-112z',
                4:'-114x243y-295z',
                5:'-119x361y-123z',
                6:'-11x161y-365z',
                7:'-124x361y-116z',
                8:'-125x234y-298z',
                9:'-135x225y-301z',
                10:'-137x353y-126z',
                11:'-143x353y-120z',
                12:'-145x215y-303z',
                13:'-155x205y-306z',
                14:'-155x344y-130z',
                15:'-160x344y-124z',
                16:'-163x194y-309z',
                17:'-171x183y-311z',
                18:'-172x334y-134z',
                19:'-178x171y-314z',
                20:'-178x334y-127z',
                21:'-184x160y-316z',
                22:'-189x324y-138z',
                23:'-190x148y-318z',
                24:'-194x323y-131z',
                25:'-195x136y-321z',
                26:'-199x124y-323z',
                27:'-19x157y-367z',
                28:'-201x6y-345z',
                29:'-202x112y-326z',
                30:'-204x17y-343z',
                31:'-205x312y-141z',
                32:'-205x99y-328z',
                33:'-206x28y-341z',
                34:'-207x40y-339z',
                35:'-207x87y-330z',
                36:'-208x51y-337z',
                37:'-208x75y-332z',
                38:'-209x63y-335z',
                39:'-210x311y-135z',
                40:'-220x300y-145z',
                41:'-225x299y-139z',
                42:'-235x287y-149z',
                43:'-240x286y-142z',
                44:'-248x273y-153z',
                45:'-252x310y-1z',
                46:'-253x272y-146z',
                47:'-261x258y-156z',
                48:'-266x257y-150z',
                49:'-268x296y-5z',
                50:'-273x243y-160z',
                51:'-278x242y-154z',
                52:'-27x152y-368z',
                53:'-283x282y-9z',
                54:'-284x228y-164z',
                55:'-289x226y-157z',
                56:'-294x211y-167z',
                57:'-297x266y-13z',
                58:'-299x209y-161z',
                59:'-304x195y-171z',
                60:'-309x192y-165z',
                61:'-311x250y-17z',
                62:'-312x178y-174z',
                63:'-319x160y-178z',
                64:'-323x234y-21z',
                65:'-326x143y-182z',
                66:'-331x125y-185z',
                67:'-335x107y-189z',
                68:'-335x216y-25z',
                69:'-339x88y-192z',
                70:'-341x70y-196z',
                71:'-342x16y-206z',
                72:'-342x34y-203z',
                73:'-342x52y-199z',
                74:'-345x198y-29z',
                75:'-34x147y-370z',
                76:'-355x180y-33z',
                77:'-35x284y-279z',
                78:'-364x161y-37z',
                79:'-371x141y-41z',
                80:'-378x121y-45z',
                81:'-383x101y-49z',
                82:'-387x81y-53z',
                83:'-391x61y-56z',
                84:'-393x40y-60z',
                85:'-394x0y-68z',
                86:'-394x19y-64z',
                87:'-396x219y-210z',
                88:'-41x141y-371z',
                89:'-42x382y-107z',
                90:'-47x135y-373z',
                91:'-49x279y-282z',
                92:'-53x129y-374z',
                93:'-54x1y-396z',
                94:'-58x123y-376z',
                95:'-58x4y-395z',
                96:'-62x116y-377z',
                97:'-62x379y-111z',
                98:'-62x8y-395z',
                99:'-63x273y-284z',
                100:'-65x12y-394z',
                101:'-66x110y-378z',
                102:'-67x380y-104z',
                103:'-68x16y-393z',
                104:'-70x103y-379z',
                105:'-71x21y-392z',
                106:'-73x96y-381z',
                107:'-74x26y-392z',
                108:'-75x89y-382z',
                109:'-76x266y-287z',
                110:'-76x31y-391z',
                111:'-77x37y-390z',
                112:'-77x82y-383z',
                113:'-79x43y-389z',
                114:'-79x75y-384z',
                115:'-80x49y-388z',
                116:'-80x55y-387z',
                117:'-80x62y-386z',
                118:'-80x69y-385z',
                119:'-81x374y-115z',
                120:'-86x375y-108z',
                121:'-89x259y-290z'}

#"
#/>


# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire400six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire400six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE400SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE400SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE400SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE400SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE400SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six4004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE400SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE400SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE400SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six400x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six400x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE400SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE400SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE400SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire400six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
